\begin{tikzpicture}[
	really thick/.style={line width=2pt},
	tool/.style={rounded corners, draw, align=center},
	code/.style={rectangle, draw, align=center},
	scale=0.4,
]

	\filldraw[fill=red, draw=black, opacity=0.66] (0, 0) rectangle (2, 2);
	\filldraw[fill=blue, draw=black, opacity=0.66] (1.25, 1.25) rectangle (2.75, 2.75);
	\filldraw[fill=yellow, draw=black, opacity=0.66] (0, 2) -- (1, 3) -- (3, 1) -- (2, 0) -- cycle;
	\draw[->] (-0.2,0) -- (3.5,0) node[right] {};
	\draw[->] (0,-0.2) -- (0,3.5) node[above] {};
	\foreach \i in {0, ..., 3} \draw[shift={(\i, 0)}] (0, 0.1) -- (0, -0.1) node[below] {};
	\foreach \i in {0, ..., 3} \draw[shift={(0, \i)}] (0.1, 0) -- (-0.1, 0) node[left] {};
	\draw (-0.3, -0.3) rectangle (3.9, 4.8);
	\node at (1.8, 4.2) {\texttt{ranks =}};
	\coordinate (polys) at (3.9, 2.4);

	\node (qoratom) [right=2em of polys, tool] {QoraTom};
	\node (ranker) [below=2em of qoratom, tool] {QoS\\ranker};
	\draw[->, really thick] (polys) -- (qoratom);
	\draw[<->, really thick] (qoratom) -- (ranker);

	\pause
	\node (code) [right=2em of qoratom, code] {\texttt{ranks =}\\\texttt{[0.25,}\\\texttt{0.5]}};
	\draw[->, really thick] (qoratom) -- (code);

	\pause
	\node (minizinc) [right=2em of code, tool] {MiniZinc/\\MiniBrass};
	\draw[->, really thick] (code) -- (minizinc);
	\node (output) [code, right=2em of minizinc, align=center] {Choose\\$\text{Pr}_2$};
	\draw[->, really thick] (minizinc) -- (output);
\end{tikzpicture}